// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "dawnlibs.hpp"
#include "dawnopenal.hpp"
#include "assert/assert.hpp"
#include "util/mathutils.hpp"

namespace Dawn {
  class AudioSource;

  class AudioData {
    private:
      ALuint buffer;
      bool_t ready = false;
      ALenum format;

    public:

      AudioData();

      void init();

      ~AudioData();

      friend class AudioSource;
  };
}