// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scenes/PixelVNScene.hpp"
#include "scenes/Scene_14.hpp"

namespace Dawn {
  class Scene_13 : public PixelVNScene {
    protected:
      void vnStage() override {
        PixelVNScene::vnStage();
      }

      void onSceneEnded() {
        auto scene = new SubSceneRendererScene<Scene_14>(this->game);
        game->assetManager.queueSwap(
          scene->getRequiredAssets(), this->getRequiredAssets()
        );
        game->assetManager.syncLoad();
        scene->stage();
        this->game->sceneCutover(scene);
      }

      IVisualNovelEvent * getVNEvent() override {
        auto start = new VisualNovelPauseEvent(vnManager, 0.1f);

        start
          ->then(new VisualNovelTextboxEvent(vnManager, nullptr, "scene.13.1"))
          ->then(new VisualNovelCallbackEvent<Scene_13>(vnManager, this, &Scene_13::onSceneEnded))
        ;

        return start;
      }

    public:
      Scene_13(DawnGame *game) : PixelVNScene(game) {
      }

      std::vector<Asset*> getRequiredAssets() override {
        std::vector<Asset*> assets = PixelVNScene::getRequiredAssets();
        return assets;
      }
  };
}